/***************************************************************************
                          pkgdialog.h  -  description
                             -------------------
    begin                : Don Jan 8 2004
    copyright            : (C) 2007 by Nicola Doebelin
    email                : ndoebelin@gmx.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PKGDIALOG_H
#define PKGDIALOG_H

#include <ui_pkgdlg.h>

class QString;
class QStringList;
class QListWigetItem;
class QFont;

/**
  *@author Nicola Doebelin
  */

class PkgDialog : public QDialog, private Ui::PkgDlg
{

   Q_OBJECT

public: 

  PkgDialog(QWidget *parent=0);
  ~PkgDialog();

  int listWidgetCount();
  QListWidgetItem * takeItem(int);
  QString lineEditText();
  void setSuffix(const QString &);
  void setDirs(const QString &, const QString &);
  void setTitle(const QString &);
  void setLabel(const QString &);
  void setItems(const QStringList &);

  QStringList getItems();

private:
  QString tdir, ltdir, file_suffix;
  bool abort, scanning;
  QFont font;

  void searchFiles(QString);
  void abortScanning();
  void toggleButtonState(bool);

private slots:
  void slotScan();
  void insertStyle(QString);
  void slotAddManually();
  void slotRemoveManually();

signals:
  void styleFound(QString);

};

#endif
