/***************************************************************************
                          previewdialog.cpp  -  description
                             -------------------
    begin                : Sam Nov 29 2003
    copyright            : (C) 2003 by Nicola Doebelin
    email                : ndoebelin@gmx.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "previewdialog.h"
#include <QTextEdit>
#include <QFontComboBox>
#include <QSpinBox>
#include <QFont>


PreviewDialog::PreviewDialog(QWidget *parent) : QDialog(parent)
{
	setupUi(this);

	connect(fontComboBox, SIGNAL(currentFontChanged(const QFont &)), this, SLOT(fontChanged(const QFont &)));
	connect(spinBoxFontSize, SIGNAL(valueChanged(int)), this, SLOT(fontSizeChanged(int)));
}

PreviewDialog::~PreviewDialog()
{
}

void PreviewDialog::setText(const QString &s)
{
	textEdit->setText(s);
}

void PreviewDialog::setFont(const QFont &f)
{
	textEdit->setFont(f);
	fontComboBox->setCurrentFont(f);
	spinBoxFontSize->setValue(f.pointSize());
}

const QFont & PreviewDialog::getFont()
{
	return textEdit->font();
}

void PreviewDialog::fontChanged(const QFont &f)
{
	textEdit->setFont(f);
}

void PreviewDialog::fontSizeChanged(int i)
{
	QFont f = textEdit->font();
	f.setPointSize(i);
	textEdit->setFont(f);
}
