/***************************************************************************
                          settingsdialog.cpp  -  description
                             -------------------
    begin                : Son Dez 7 2003
    copyright            : (C) 2003 by Nicola Doebelin
    email                : adoebelin@gmx.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "settingsdialog.h"
#include <QFileDialog>
#include <QLineEdit>
#include <QMessageBox>
#include <QString>
#include <QCheckBox>

SettingsDialog::SettingsDialog(QWidget *parent) : QDialog(parent)
{
  setupUi(this);

  connect(buttonSaveAll, SIGNAL(clicked()), this, SLOT(allSaved()));
  connect(buttonWorkingDir, SIGNAL(clicked()), this, SLOT(wdChanged()));
  connect(buttonTexDir, SIGNAL(clicked()), this, SLOT(tdChanged()));
  connect(buttonLTexDir, SIGNAL(clicked()), this, SLOT(ltdChanged()));
}

SettingsDialog::~SettingsDialog()
{
}

void SettingsDialog::setWd(QString s)
{
	lineEditWorkingDir->setText(s);
}

QString SettingsDialog::getWd()
{
	return lineEditWorkingDir->text();
}

void SettingsDialog::setTd(QString s)
{
	lineEditTexDir->setText(s);
}

QString SettingsDialog::getTd()
{
	return lineEditTexDir->text();
}

void SettingsDialog::setLtd(QString s)
{
	lineEditLTexDir->setText(s);
}

QString SettingsDialog::getLtd()
{
	return lineEditLTexDir->text();
}

void SettingsDialog::wdChanged()
{
	QString s = QFileDialog::getExistingDirectory(this, tr("Select Working Directory"),
		lineEditWorkingDir->text());

	if (s.isEmpty()) return;
	lineEditWorkingDir->setText(s);
}

void SettingsDialog::tdChanged()
{
	QString s = QFileDialog::getExistingDirectory(this, tr("Select texmf Directory"),
		lineEditTexDir->text());

	if (s.isEmpty()) return;
	lineEditTexDir->setText(s);
}

void SettingsDialog::ltdChanged()
{
	QString s = QFileDialog::getExistingDirectory(this, tr("Select localtexmf Directory"),
		lineEditLTexDir->text());

	if (s.isEmpty()) return;
	lineEditLTexDir->setText(s);
}

void SettingsDialog::setRestoreSize(bool b)
{
	checkBoxSize->setChecked(b);
}

bool SettingsDialog::getRestoreSize()
{
	return checkBoxSize->isChecked();
}

void SettingsDialog::setRestorePos(bool b)
{
	checkBoxPos->setChecked(b);
}

bool SettingsDialog::getRestorePos()
{
	return checkBoxPos->isChecked();
}

void SettingsDialog::allSaved()
{
	emit saveAll();
	QMessageBox::information(0, tr("Default settings saved"),
                           tr("Current settings were saved as defaults."));
}
