/***************************************************************************
                          template.cpp  -  description
                             -------------------
    begin                : Mon Jul 24 16:47:18 CET 2005
    copyright            : (C) 2005 by Nicola Doebelin
    email                : ndoebelin@gmx.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "template.h"

Template::Template(QString n)
{
  if (n.isEmpty()) _name = "";
  else             _name = n;

  inlineSep = "|";

  _title = "";
  _author = "";

  _customMarkup = QStringList("");

  _docClass = 0;
  _paperSize = 0;
  _fontSize = 0;
  _fontFam = 0;
  _outputFormat = 0;
  _encoding = 0;
  _language = 0;

  _koma = false;
  _setCustomMarkup = false;

  _date.setYMD(0, 0, 0);

  _sdate = false;

  _titlePButton = 0;

  _head = "";
  _subject = "";
  _publisher = "";
  _thanks = "";
  _extra = "";
  _dedication = "";
  _top = "";
  _bottom = "";

  _duplex = 0;
  _columns = 0;
  _orientation = 0;
  _lineSpacing = 0;
  _pageStyle = 0;
  _floatPageFrac = 0;

  _sloppy = false;

  _toc = false;
  _lof = false;
  _lot = false;
  _index = false;
  _bibliography = false;

  _lofToc = false;
  _idxToc = false;
  _bibToc = false;

  _tocdepth = 0;

  _div = 0;
  _bcor = 0;
  _headingSize = 0;
  _captions = 0;
  _bibType = 0;
  _bibStyle = 0;

  _bibDb = "";

  _bibStyleList = QStringList("");
  _pkgsAvailable = QStringList("");
  _pkgsLoaded = QStringList("");
}

Template::~Template()
{
}

QString Template::bts(bool b)
{
  QString s;
  if (b) s = "true";
  else   s = "false";
  return s;
}

bool Template::stb(const QString &s)
{
  bool b;
  if (s == "true") b = true;
  else             b = false;
  return b;
}

void Template::setFromStringList(const QStringList &l)
{
  QStringList lst = l;
  QStringList::iterator it = lst.begin();

  _name = *it;
    it++;
  _title = *it;
    it++;
  _author = *it;
    it++;

  _customMarkup = it->split(inlineSep, QString::SkipEmptyParts);
    it++;

  _docClass = (*it).toInt();
    it++;
  _paperSize = (*it).toInt();
    it++;
  _fontSize = (*it).toInt();
    it++;
  _fontFam = (*it).toInt();
    it++;
  _outputFormat = (*it).toInt();
    it++;
  _encoding = (*it).toInt();
    it++;
  _language = (*it).toInt();
    it++;

  _koma = stb(*it);
    it++;
  _setCustomMarkup = stb(*it);
    it++;

  _sdate = stb(*it);
    it++;
  _date = QDate::fromString(*it);
    it++;

  _titlePButton = (*it).toInt();
    it++;

  _head = *it;
    it++;
  _subject = *it;
    it++;
  _publisher = *it;
    it++;
  _thanks = *it;
    it++;
  _extra = *it;
    it++;
  _dedication = *it;
    it++;
  _top = *it;
    it++;
  _bottom = *it;
    it++;

  _duplex = (*it).toInt();
    it++;
  _columns = (*it).toInt();
    it++;
  _orientation = (*it).toInt();
    it++;
  _lineSpacing = (*it).toInt();
    it++;
  _pageStyle = (*it).toInt();
    it++;
  _floatPageFrac = (*it).toInt();
    it++;

  _sloppy = stb(*it);
    it++;

  _toc = stb(*it);
    it++;
  _lof = stb(*it);
    it++;
  _lot = stb(*it);
    it++;
  _index = stb(*it);
    it++;
  _bibliography = stb(*it);
    it++;

  _lofToc = stb(*it);
    it++;
  _idxToc = stb(*it);
    it++;
  _bibToc = stb(*it);
    it++;

  _tocdepth = (*it).toInt();
    it++;

  _div = (*it).toInt();
    it++;
  _bcor = (*it).toInt();
    it++;
  _headingSize = (*it).toInt();
    it++;
  _captions = (*it).toInt();
    it++;

  _bibType = (*it).toInt();
    it++;
  _bibStyle = (*it).toInt();
    it++;

  _bibDb = *it;
    it++;

  _bibStyleList = it->split(inlineSep, QString::SkipEmptyParts);
    it++;

  _pkgsAvailable = it->split(inlineSep, QString::SkipEmptyParts);
    it++;
  _pkgsLoaded = it->split(inlineSep, QString::SkipEmptyParts);

}

void Template::setFromLongStringList(const QStringList &l)
{
  QStringList lst = l, out;
  QStringList::iterator it;

  for (it = lst.begin(); it != lst.end(); it++) {
    it++;
    if (it == lst.end()) break;
    out.append(*it);
  }

  setFromStringList(out);
}

QStringList Template::writeToStringList()
{
  QString str;
  QStringList lst;

  lst.push_back("Name"); 
    lst.push_back(_name);
  lst.push_back("Title"); 
    lst.push_back(_title);
  lst.push_back("Author"); 
    lst.push_back(_author);

  lst.push_back("Custom Markup Commands"); 
    lst.push_back(_customMarkup.join(inlineSep));

  lst.push_back("Document Class");
    lst.push_back(str.setNum(_docClass));
  lst.push_back("Paper Size");
    lst.push_back(str.setNum(_paperSize));
  lst.push_back("Font Size");
    lst.push_back(str.setNum(_fontSize));
  lst.push_back("Font Family");
    lst.push_back(str.setNum(_fontFam));
  lst.push_back("Output Forma");
    lst.push_back(str.setNum(_outputFormat));
  lst.push_back("Encoding");
    lst.push_back(str.setNum(_encoding));
 lst.push_back("Language");
    lst.push_back(str.setNum(_language));

  lst.push_back("KOMA Script");
    lst.push_back(bts(_koma));
  lst.push_back("Use Custom Markup Cmds.");
    lst.push_back(bts(_setCustomMarkup));

  lst.push_back("Static Date");
    lst.push_back(bts(_sdate));
  lst.push_back("Date");
    lst.push_back(_date.toString());

  lst.push_back("Title Page");
    lst.push_back(str.setNum(_titlePButton));

  lst.push_back("Title Head");
    lst.push_back(_head);
  lst.push_back("Subject");
    lst.push_back(_subject);
  lst.push_back("Publisher");
    lst.push_back(_publisher);
  lst.push_back("Acknowledgment");
    lst.push_back(_thanks);
  lst.push_back("Extra Title");
    lst.push_back(_extra);
  lst.push_back("Dedication");
    lst.push_back(_dedication);
  lst.push_back("Backside Title Top");
    lst.push_back(_top);
  lst.push_back("Backside Title Bottom");
    lst.push_back(_bottom);

  lst.push_back("Duplex");
    lst.push_back(str.setNum(_duplex));
  lst.push_back("Columns");
    lst.push_back(str.setNum(_columns));
  lst.push_back("Orientation");
    lst.push_back(str.setNum(_orientation));
  lst.push_back("Line Spacing");
    lst.push_back(str.setNum(_lineSpacing));
  lst.push_back("Page Style");
    lst.push_back(str.setNum(_pageStyle));
  lst.push_back("Float Page Fraction");
    lst.push_back(str.setNum(_floatPageFrac));

  lst.push_back("Sloppy");
    lst.push_back(bts(_sloppy));

  lst.push_back("Table of Contents");
    lst.push_back(bts(_toc));
  lst.push_back("List of Figures");
    lst.push_back(bts(_lof));
  lst.push_back("List of Tables");
    lst.push_back(bts(_lot));
  lst.push_back("Index");
    lst.push_back(bts(_index));
  lst.push_back("Bibliography");
    lst.push_back(bts(_bibliography));

  lst.push_back("Lists to TOC");
    lst.push_back(bts(_lofToc));
  lst.push_back("Index to TOC");
    lst.push_back(bts(_idxToc));
  lst.push_back("Bibliography to TOC");
    lst.push_back(bts(_bibToc));

  lst.push_back("TOC depth");
    lst.push_back(str.setNum(_tocdepth));

  lst.push_back("DIV");
    lst.push_back(str.setNum(_div));
  lst.push_back("BCOR");
    lst.push_back(str.setNum(_bcor));
  lst.push_back("Heading Size");
    lst.push_back(str.setNum(_headingSize));
  lst.push_back("Captions Layout");
    lst.push_back(str.setNum(_captions));

  lst.push_back("Bibliography Type");
    lst.push_back(str.setNum(_bibType));
  lst.push_back("BibTeX Style");
    lst.push_back(str.setNum(_bibStyle));

  lst.push_back("BibTeX Database");
    lst.push_back(_bibDb);

  lst.push_back("BibTeX Styles");
    lst.push_back(_bibStyleList.join(inlineSep));

  lst.push_back("Available Packages");
    lst.push_back(_pkgsAvailable.join(inlineSep));
  lst.push_back("Loaded Packages");
    lst.push_back(_pkgsLoaded.join(inlineSep));

  return lst;
}


